:userdoc.

.******************************************************************************
.* Main Description Page                                                      *
.******************************************************************************
:h1 res=100 name=PANEL_GENERAL.Systray general help
:p.
:hp2.Systray:ehp2. is a complete system control center with a set of
system monitors, task switcher, toolbar like in WarpCenter and System
TRAY technology.
:p.
A work area of Systray is a horizontal bar. Systray can contain one or more small
elements called :hp4."units":ehp4.. All units that you see on Systray are from
:hp4.plugins:ehp4. located in :hp2.\PLUGINS:ehp2. folder. This means that Systray
can be easyly extended by adding new and new plugins.
:p.
Each unit shows its data (what it's doing now) on Systray in a bar.
You can change units width by mouse (by dragging vertical bar at right unit
side), move it and call other functions of unit by selecting desired functions
from unit popup menu. Popup menu can be called by clicking right mouse button
on any unit.
:p.
:hp2.See also&colon.:ehp2.
:sl.
:li.:link reftype=hd res=101.Systray view settings:elink.
:esl.

.******************************************************************************
.* Settings #1 page                                                           *
.******************************************************************************
:h1 res=101 name=PANEL_SETTINGS.Systray view settings
:p.
The first "View" page in a Systray settings notebook allows you to customize
Systray look. They explanation&colon.
:p.
:dl break=all.
:dt.:hp4.Border width:ehp4.
:dd.This allows you to set border width (in pixels).
Note that border width can be set to 0, meaning that border will be
:hp2.invisible:ehp2..

:dt.:hp4.View spacing:ehp4.
:dd.This allows you to set spacing amount (in pixels) between border and units
on Systray bar. If you set it to 0, there :hp2.will be no spacing:ehp2. at all.

:dt.:hp4.Unit spacing:ehp4.
:dd.This allows you to set spacing amount (in pixels) between units
on Systray bar. If you set it to 0, there :hp2.will be no spacing:ehp2.
between units at all.

:dt.:hp4.View height:ehp4.
:dd.This allows you to set Systray bar height (in rows). See also
"Adding units" section for explanation how to set up multi-row units
configuration.

:dt.:hp4.Row height:ehp4.
:dd.This allows you to set each row height (in pixels). 

:dt.:hp4.Position on screen:ehp4.
:dd.This allows you to set Systray bar position. You can select 2
positions: on screen :hp2.top:ehp2. or :hp2.bottom:ehp2. corner.
You also can turn on :hp2."Resize desktop":ehp2. check box, if you
wish to make Systray bar always visible on any maximized window.
:edl.

.******************************************************************************
.* Taskbar page                                                               *
.******************************************************************************
:h1 res=102 name=PANEL_TASKSWITCHER.Task switcher
:p.
Using :hp2.Task Switcher:ehp2. you can switch between different tasks by
single mouse click. Tasks shown as horizontal buttons with its icon and title.
Task with current focus is shown with pressed button and highlighted background&colon.
:p.
By clicking right mouse button you may invoke task's system menu with standart
window actions (:hp2.Restore:ehp2., :hp2.Move:ehp2., :hp2.Minimize:ehp2., 
:hp2.Maximize:ehp2., etc). Single LMB click will switch focus and bring on
top selected task, another click on window that already have focus 
will hide this task.
:p.
You can also hide any task from Task Switcher unit.

.******************************************************************************
.* FreeRAM page                                                               *
.******************************************************************************
:h1 res=103 name=PANEL_RAMMONITOR.Available physical memory monitor
:p.
:hp2.Free RAM:ehp2. monitor displays to you amount of available physical
memory on your OS/2 system. This monitor updated every second.
:p.
For customizing monitor look, use :hp4.Color:ehp4. and :hp4.Font palette:ehp4.,
or unit properties notebook, page :hp4."Presentation":ehp4..

.******************************************************************************
.* Swapper page                                                               *
.******************************************************************************
:h1 res=104 name=PANEL_SWAPMONITOR.Swap file size
:p.
:hp2.Swap:ehp2. monitor displays to you :hp2.SWAPPER.DAT:ehp2. file size.This
monitor updated every 10 seconds.
:p.
For customizing monitor look, use :hp4.Color:ehp4. and :hp4.Font palette:ehp4.,
or unit properties notebook, page :hp4."Presentation":ehp4..

.******************************************************************************
.* Pipe monitor                                                               *
.******************************************************************************
:h1 res=105 name=PANEL_PIPEMONITOR.Pipe monitor
:p.
Pipe monitor.

.******************************************************************************
.* System Tray                                                                *
.******************************************************************************
:h1 res=106 name=PANEL_SYSTRAYONITOR.System tray
:p.
System tray.

.******************************************************************************
.* Warpbutton                                                                 *
.******************************************************************************
:h1 res=107 name=PANEL_WARPBUTTON.Warpbutton
:p.
Warpbutton.

.******************************************************************************
.* Toolbar                                                                    *
.******************************************************************************
:h1 res=108 name=PANEL_TOOLBAR.Toolbar
:p.
Toolbar.

.******************************************************************************
.* Disk monitor                                                               *
.******************************************************************************
:h1 res=109 name=PANEL_DISKMONITOR.Disk monitor
:p.
Disk monitor.

.******************************************************************************
.* Cool unit                                                                  *
.******************************************************************************
:h1 res=110 name=PANEL_DISKMONITOR.Cool unit
:p.
Cool unit.

:euserdoc.